ICode9

精准搜索请尝试: 精确搜索
首页 > 其他分享> 文章详细

Codeforces Round #598 (Div. 3) C. Platforms Jumping 贪心或dp

2019-11-05 15:56:21  阅读:338  来源: 互联网

标签:Platforms int 598 Codeforces should platform platforms position dp


C. Platforms Jumping

There is a river of width n. The left bank of the river is cell 0 and the right bank is cell n+1 (more formally, the river can be represented as a sequence of n+2 cells numbered from 0 to n+1). There are also m wooden platforms on a river, the i-th platform has length ci (so the i-th platform takes ci consecutive cells of the river). It is guaranteed that the sum of lengths of platforms does not exceed n.

You are standing at 0 and want to reach n+1 somehow. If you are standing at the position x, you can jump to any position in the range [x+1;x+d]. However you don't really like the water so you can jump only to such cells that belong to some wooden platform. For example, if d=1, you can jump only to the next position (if it belongs to the wooden platform). You can assume that cells 0 and n+1 belong to wooden platforms.

You want to know if it is possible to reach n+1 from 0 if you can move any platform to the left or to the right arbitrary number of times (possibly, zero) as long as they do not intersect each other (but two platforms can touch each other). It also means that you cannot change the relative order of platforms.

Note that you should move platforms until you start jumping (in other words, you first move the platforms and then start jumping).

For example, if n=7, m=3, d=2 and c=[1,2,1], then one of the ways to reach 8 from 0 is follow:

The first example: n=7.

Input

The first line of the input contains three integers n, m and d (1≤n,m,d≤1000,m≤n) — the width of the river, the number of platforms and the maximum distance of your jump, correspondingly.

The second line of the input contains m integers c1,c2,…,cm (1≤ci≤n,∑i=1mci≤n), where ci is the length of the i-th platform.

Output

If it is impossible to reach n+1 from 0, print NO in the first line. Otherwise, print YES in the first line and the array a of length n in the second line — the sequence of river cells (excluding cell 0 and cell n+1).

If the cell i does not belong to any platform, ai should be 0. Otherwise, it should be equal to the index of the platform (1-indexed, platforms are numbered from 1 to m in order of input) to which the cell i belongs.

Note that all ai equal to 1 should form a contiguous subsegment of the array a of length c1, all ai equal to 2 should form a contiguous subsegment of the array a of length c2, ..., all ai equal to m should form a contiguous subsegment of the array a of length cm. The leftmost position of 2 in a should be greater than the rightmost position of 1, the leftmost position of 3 in a should be greater than the rightmost position of 2, ..., the leftmost position of m in a should be greater than the rightmost position of m−1.

See example outputs for better understanding.

Examples

input
7 3 2
1 2 1
output
YES
0 1 0 2 2 0 3
input
10 1 11
1
output
YES
0 0 0 0 0 0 0 0 0 1
input
10 1 5
2
output
YES
0 0 0 0 1 1 0 0 0 0

Note

Consider the first example: the answer is [0,1,0,2,2,0,3]. The sequence of jumps you perform is 0→2→4→5→7→8.

Consider the second example: it does not matter how to place the platform because you always can jump from 0 to 11.

Consider the third example: the answer is [0,0,0,0,1,1,0,0,0,0]. The sequence of jumps you perform is 0→5→6→11.

题意

现在有长度为n的河,河上面你需要摆放m个木板,第i个木板的长度为c[i],木板与木板之间的摆放不能交叉,现在问你是否存在一个方案,能够拜访这些木板。

题解

贪心,我们假设所有木板都在最后面摆放。然后我开始跳跃,如果我脚下没有木板,我就从后面拿一块木板放在脚下即可。

dp,dp[i][j]表示我现在在i位置,是站在第j块木板的开始,然后开始转移即可。

代码

#include<bits/stdc++.h>
using namespace std;
const int maxn = 1005;
int n,m,d;
int c[maxn];
int dp[maxn][maxn];
int from[maxn][maxn];
int plan[maxn];
void print_plan(){
    //plan[n]=m;
    int now=n;
    int j=m;
    while(j>0){
        for(int i=from[now][j];i<from[now][j]+c[j-1];i++){
            plan[i]=j-1;
        }
        now=from[now][j];
        j--;
    }
    for(int i=1;i<n;i++){
        cout<<plan[i]<<" ";
    }
    cout<<endl;
}
int main(){
    scanf("%d%d%d",&n,&m,&d);
    for(int i=1;i<=m;i++){
        scanf("%d",&c[i]);
    }
    c[0]=1;
    n++;m++;c[m]=1;
    dp[0][0]=1;
    for(int i=1;i<=n;i++){
        for(int j=1;j<=m;j++){
            for(int k=1;k<=d;k++){
                if(i-k-c[j-1]+1>=0&&dp[i-k-c[j-1]+1][j-1]){
                    dp[i][j]=1;
                    from[i][j]=i-k-c[j-1]+1;
                }
            }
        }
    }
    if(dp[n][m]==1){
        puts("YES");
        print_plan();
    }else{
        puts("NO");
    }
}

标签:Platforms,int,598,Codeforces,should,platform,platforms,position,dp
来源: https://www.cnblogs.com/qscqesze/p/11798928.html

本站声明: 1. iCode9 技术分享网(下文简称本站)提供的所有内容,仅供技术学习、探讨和分享;
2. 关于本站的所有留言、评论、转载及引用,纯属内容发起人的个人观点,与本站观点和立场无关;
3. 关于本站的所有言论和文字,纯属内容发起人的个人观点,与本站观点和立场无关;
4. 本站文章均是网友提供,不完全保证技术分享内容的完整性、准确性、时效性、风险性和版权归属;如您发现该文章侵犯了您的权益,可联系我们第一时间进行删除;
5. 本站为非盈利性的个人网站,所有内容不会用来进行牟利,也不会利用任何形式的广告来间接获益,纯粹是为了广大技术爱好者提供技术内容和技术思想的分享性交流网站。

专注分享技术,共同学习,共同进步。侵权联系[81616952@qq.com]

Copyright (C)ICode9.com, All Rights Reserved.

ICode9版权所有